﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.32
@EndOfDesignText@
Sub Class_Globals
	Private nativeMe As JavaObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	nativeMe = Me
End Sub


Public Sub WakeOnLan(brodacastIP As String, macAddress As String) As Boolean
	Return  nativeMe.RunMethod("WakeOnLan", Array(brodacastIP, macAddress))
End Sub

#if JAVA

import java.io.*;
import java.net.*;


public boolean  WakeOnLan(String BROADCASTIP, String MACADDRESS) {
   
   		int PORT = 9;   
        String ipStr = BROADCASTIP;
        String macStr = MACADDRESS;
       
		try {
            byte[] macBytes = getMacBytes(macStr);
            byte[] bytes = new byte[6 + 16 * macBytes.length];
            for (int i = 0; i < 6; i++) {
                bytes[i] = (byte) 0xff;
            }
            for (int i = 6; i < bytes.length; i += macBytes.length) {
                System.arraycopy(macBytes, 0, bytes, i, macBytes.length);
            }
           
            InetAddress address = InetAddress.getByName(ipStr);
            DatagramPacket packet = new DatagramPacket(bytes, bytes.length, address, PORT);
            DatagramSocket socket = new DatagramSocket();
            socket.send(packet);
            socket.close();
           
            System.out.println("Wake-on-LAN packet sent.");
			return true;
        }
        catch (Exception e) {
            System.out.println("Failed to send Wake-on-LAN packet: + e");
          	return false;
        }
       
 }
   
  private static byte[] getMacBytes(String macStr) throws IllegalArgumentException {
        byte[] bytes = new byte[6];
        String[] hex = macStr.split("(\\:|\\-)");
        if (hex.length != 6) {
            throw new IllegalArgumentException("Invalid MAC address.");
        }
        try {
            for (int i = 0; i < 6; i++) {
                bytes[i] = (byte) Integer.parseInt(hex[i], 16);
            }
        }
        catch (NumberFormatException e) {
            throw new IllegalArgumentException("Invalid hex digit in MAC address.");
        }
        return bytes;
    }
   
  

#End If
